#antislap.uafs.tcl
#    ,    
#action (  ) , ,    , 
#      (c) Red Pepper

# version:1.1 by 
# CoolCold <menya [at] vse.zae.blo.org.ru>
# #rea@irc.coolcold.org:6667
#
#  __    __  __    _           _    
# \  \  /  /|  \  | |         | |   
#  \  \/  / |   \ | |  ____  _| |_  
#   \    /  | |\ \| | /  _ \|_   _| 
#   /    \  | | \   | | /_\/  | |   
#  /  /\  \ | |  \  | | \__   | |__ 
# /__/  \__\|_|   \_| \____/  \___/ 
#
# http://xnet.net.ru irc://xnet.net.ru
#
#
#
#               :::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
#
#
# Created with FAR ( http://www.farmanager.com )
# and colorer ( http://colorer.sf.net )
#
#
# Requirements:
# eggdrop (windrop) 1.6.x (others should work too )
# tcl 8.3.x and 8.4.x ( others not tested )
# UAFS pre beta 6 or later (http://web.coolcold.org/scripts/uafs/)


#    
#       namespaces, 
#      .

namespace eval antislapw {

        #settings should be here...if any :)
        
        #  -   2   60 
        set slaplimit "2:60"
        
        #        
        set ignoreflags "f|f"
   
        # 
        # %s        ,
        #   %s  
        set frases ""
        lappend frases ", %s,   ,    !"
        lappend frases "%s,     !"
        lappend frases "%s, %s,     !"


        #########################################
        #                                       #
        #    -  #
        #                                       #
        #########################################
		
        #  putlog    
        #  -   putlog ;)
        proc putlog { text } {
                if {$text!=""} {
                        ::putlog "--- AntiSlap: $text"
                }
        }
        
        putlog "Loading antislap.uafs.tcl..."
        
        
        set ufh ""
        set ver "1.1"
        set infoline "antislap.uafs.tcl with uafs support,by \"Red Pepper\"'s request"
        set author {CoolCold <menya [at] vse.zae.blo.org.ru>}
        set powered "Powered by FAR & Colorer"
        putlog "$powered"
        set respectz "Respects to Shrike,MrBug,Drakon_,Twin and http://eggdrop.org.ru"
        set eggdroporgrulogo ""
        lappend eggdroporgrulogo {               :::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: }
    	lappend eggdroporgrulogo {0,1      ____                __                                                      }
    	lappend eggdroporgrulogo {0,1     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   }
    	lappend eggdroporgrulogo {12,1    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   }
    	lappend eggdroporgrulogo {4,1   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    }
    	lappend eggdroporgrulogo {4,1        /___/ /___/                 /_/    /_/           /___/ /_/                }

    	::putlog ""
    	foreach i $eggdroporgrulogo { putlog $i }
       
		::putlog ""       
        putlog "$respectz"
	
        ::putlog ""
        #  bind'
        putlog "Removing our old binds ( if any ) ..."
        set tbinds [llength [binds "[namespace current]::*"]]
        foreach bind [binds "[namespace current]::*"] {
            catch {unbind [lindex $bind 0] [lindex $bind 1] [lindex $bind 2] [lindex $bind 4]}
        }
        putlog "$tbinds old binds removed"
	

    # -   uafs,   tcl 
    #""  -      ,  .
    # ,   ::uafs::numver  , 
    #    .
    if {[info exists "::uafs::numver"] && $::uafs::numver>="000006"} {
            #,  handler
            #  -    $slaplimit
            #  - #masks(host) -   *!*@hostname
            #     $ignoreflags
            set ufh [::uafs::registerhandle $slaplimit $::uafs::masks(host) $ignoreflags "" "0"]
            if {$ufh>0} {
                    #  , 
                    bind ctcp -|- "ACTION" ::antislapw::proc_action
            } else {
                    #           
                    putlog "registerhandle failed. error code \"$ufh\",error info: \"[::uafs::formatmessage $ufh]\""
            }
            
    } else {
            putlog "--------------------------------------------------"
            putlog "| No UAFS.tcl installed or too old version found |"
            putlog "| Install UAFS.tcl first and load it before      |"
            putlog "| loading this script!                           |"
            putlog "| Download latest version of uafs here:          |"
            putlog "|     http://web.coolcold.org/scripts/uafs/      |"
            putlog "--------------------------------------------------"
            putlog "$infoline version $ver by $author load failed"
            #  
            return 0
    }
}

proc ::antislapw::proc_action { nnick uhost hand dest keyword text } {
	global nick botnick botnet-nick
	variable frases;variable ufh
	#putlog "bingo!"
	if {$dest!=$nick && [string match -nocase "slaps*trout" $text]} {
        #   
        set flooded [::uafs::isflood $ufh $nnick $uhost $dest]

        if {$flooded=="1"} {
        	#      (  )
        	set umask [::uafs::createmask $nnick $uhost [lindex $::uafs::handles($ufh) 2]]
        	set counter [::uafs::checksoftcounter $ufh $nnick $uhost $dest]
            if {$counter<0} {
               #some error occured
               putlog "error while getting counter value, error code \"$counter\", description:[::uafs::formatmessage $counter]"
               return 0
            } 
            switch  -exact -- $counter {
            	"1" {
        			#  1  - 
   					#     ?
   					if {[botisop $dest] || [botishalfop $dest]} {
   						# , .
   						putserv "kick $dest $nnick :Stop slapping!"
   					}
   				}
        		default {
        			#  2  - 
   					#   .
   					set mask "[string tolower $umask]"
   					# .
   					newchanban $dest $mask ${botnet-nick} "  !" 1
        		}
        	}

        } elseif { $flooded == "0" } {
    		# , 

    		#  
    		set rnd [expr { round ( rand() * [llength $frases] ) }]
    		#putlog "random is $rnd"
    		if {$rnd==0} {set rnd 1};set rnd [expr $rnd - 1]
    		
    		#  ( ..      )
    		set victim [lindex [split $text ] 1]
    		#    
    		set msg [format [lindex $frases $rnd] $nnick $victim]
    		putserv "PRIVMSG $dest :$msg"
        } else {
            #  -  isflood       
            #     
            putlog "isflood check failed for ufh \"$ufh\", error info: \"[::uafs::formatmessage $ufh]\", though this shouldn't happen"
        }
		
	}
	return 0
}

namespace eval antislapw {
        if {$ufh>0} {
                putlog "$infoline version $ver by $author loaded"
        } else {
        	putlog "$infoline version $ver by $author loaded,but some errors found"
        }
}