#PM message na forume from aNt^N!0
#NOTE: PM'ing isn't good,use email next time :)

#:
#!     , .
# -      5  "!",  ,
#  5 ,    : , 2 , 
#   1 !

# version:1.1 by 
# CoolCold <menya [at] vse.zae.blo.org.ru>
# #rea@irc.coolcold.org:6667
#
#  __    __  __    _           _    
# \  \  /  /|  \  | |         | |   
#  \  \/  / |   \ | |  ____  _| |_  
#   \    /  | |\ \| | /  _ \|_   _| 
#   /    \  | | \   | | /_\/  | |   
#  /  /\  \ | |  \  | | \__   | |__ 
# /__/  \__\|_|   \_| \____/  \___/ 
#
# http://xnet.net.ru irc://xnet.net.ru
#
#
#
#               :::[  T h e   R u s s i a n   E g g d r o p  R e s o u r c e  ]::: 
#      ____                __                                                      
#     / __/___ _ ___ _ ___/ /____ ___   ___      ___   ____ ___ _     ____ __ __   
#    / _/ / _ `// _ `// _  // __// _ \ / _ \    / _ \ / __// _ `/    / __// // /   
#   /___/ \_, / \_, / \_,_//_/   \___// .__/ __ \___//_/   \_, / __ /_/   \___/    
#        /___/ /___/                 /_/    /_/           /___/ /_/                
#
#
#
# Created with FAR ( http://www.farmanager.com )
# and colorer ( http://colorer.sf.net )
#
#
# Requirements:
# eggdrop (windrop) 1.6.x (others should work too )
# tcl 8.3.x and 8.4.x ( others not tested )
# UAFS pre beta 6 or later (http://web.coolcold.org/scripts/uafs/)

#example4.tcl for uafs, updated for uafs beta 6
#          6 :)
#- 
namespace eval twist {
	
	set infoline "example4.tcl for uafs,updated for uafs beta 6,was born with aNt^N!0 request"
	
	#ban time in munutes
	set bantime 1

	##################################################################
	#                                                                #
	#    -        #
	#                                                                #
	##################################################################
	
	#  putlog    
	proc putlog { text } {
		if {$text!=""} {
			::putlog "--- TWIST script: $text"
		}
	}

	set ufh "-1"

	# -   uafs,   tcl 
	#""  -      ,  .
	# ,   ::uafs::numver  , 
	#    .
	if {[info exists "::uafs::numver"] && $::uafs::numver>="000006"} {
		#,  handler
		#  - 1   300 ,  - 
		#masks(host) -   *!*@hostname,  
		#  +f   +f  
		set ufh [::uafs::registerhandle "1:300" $::uafs::masks(host) "f|f"]
		if {$ufh>0} {
			#  , 
			bind pub - "!twist" ::twist::twistproc
		
		} else {
			#           
			putlog "registerhandle failed. error code \"$ufh\",error info: \"[::uafs::formatmessage $ufh]\""
		}
		
	} else {
    	putlog "--------------------------------------------------"
    	putlog "| No UAFS.tcl installed or too old version found |"
    	putlog "| Install UAFS.tcl first and load it before      |"
    	putlog "| loading this script!                           |"
		putlog "--------------------------------------------------"
	}

	proc twistproc { nick uhost hand chan rest } {
    	variable ufh;variable bantime
    	global lastbind botnet-nick
    	#   
    	set flooded [::uafs::isflood $ufh $nick $uhost $chan]
    	if {$flooded=="1"} {
    		set counter [::uafs::checksoftcounter $ufh $nick $uhost $chan]
    		if {$counter<0} {
   				#some error occured
   				putlog "error while getting counter value, error code \"$counter\", description:[::uafs::formatmessage $counter]"
   				return 0
   			}
    		#putlog "user $nick!$uhost floods me with soft flood for $counter time"
    		switch -exact -- $counter {
    			"1" {
    				#  1 ...
    				putserv "NOTICE $nick :Next time you may use \"$lastbind\" after [duration [::uafs::peacetime $ufh $nick $uhost $chan]]"
    			}
    			"2" {
    				#2 ...
    				putserv "NOTICE $nick :Achtung! Stop flooding me with \"$lastbind\""
    			}
    			"3" -
    			"4" {
    				#3  4     ...  :)
    				
    				#     ?
    				if {[botisop $chan] || [botishalfop $chan]} {
    					# , .
    					putserv "kick $chan $nick :Stop flooding me with \"$lastbind\""
    				}
    			}
    			default {
    				#     ...
    				
    				#   .
    				set mask [::uafs::createmask $nick $uhost [::uafs::gethandleinfo $ufh "hostmask"]]
    				# .
    				#putlog "setting ban on $chan mask is $mask"
           			newchanban $chan $mask ${botnet-nick} "flooded me with \"$lastbind\"" $bantime
    			}
    		}
    	} elseif {$flooded=="0"} {
    		##########################################################
    		#
    		#       :)
    		putserv "PRIVMSG $chan :$nick twisting!"
    		#
    		##########################################################
    	} else {
    		#  -  isflood       
    		#     
    		putlog "isflood check failed for ufh \"$ufh\", error info: \"[::uafs::formatmessage $ufh]\", though this shouldn't happen"
    	}
	}
}


putlog "$::twist::infoline loaded"