#demo script for uafswrapper.tcl

#defining our own namespace
#if you don't use namespaces,it is a good day to start doing this 

namespace eval testscript {

	#first of all,you should check is uafswrapper loaded or not

	putlog ""
	putlog "--- Loading UAFS wrapper demo script ---"
	putlog "Checking if UAFS wrapper is installed..."
    
    #defining bind command,please pay attention to { and } brackets
    #if you don't want to backslash quota characters (") or other simbols
    set bindcmd {bind pub -|- "!slap" ::testscript::proc_slap}

    if {[info exists "::uafswrapper::uafsloaded"]} {
    	if {$::uafswrapper::uafsloaded=="1"} {
    		putlog "---UAFS wrapper demo script: UAFS wrapper script found,continue loading"
    		
    		###################################
    		#                                 #
    		# Here all you bind should be set #
    		#                                 #
    		###################################
			
    		if {[::uafswrapper::addbind "$bindcmd"]<0} {
    			#error while adding bind
    			putlog "---UAFS wrapper demo script: an error occured while adding bind"
            	putlog "---UAFS wrapper demo script: UAFS wrapper isn't loaded or wasn't properly initialized,flood protection disabled"
            	#binding in regular way,no flood protection available!
            	eval $bindcmd
    		}
    	} else {
    		putlog "---UAFS wrapper demo script: UAFS wrapper isn't loaded or wasn't properly initialized,flood protection disabled"

    		#binding in regular way,no flood protection available!
    		eval $bindcmd
    	}
    } else {
    	putlog "---UAFS wrapper demo script: UAFS wrapper isn't loaded or wasn't properly initialized,flood protection disabled"
    	#binding in regular way,no flood protection available!
    	eval $bindcmd

    }
}

proc ::testscript::proc_slap { nick uhost hand chan text } {
putserv "PRIVMSG $chan :\001ACTION slaps $text with baka-powder\001"
}